(*
   Grafika -- a "geometria" feladatokhoz.
   Import:
      Unit Graph
      Type TPont
           TSzakasz
   Export:
      Const     Color,
                FillPattern
      Procedure GrafInic
                PontRajzol
                SzakaszRajzol
      Function  Max
                Min
*)
  Const
     pR=5; {pontsugr}
  Var
     minX,minY,maxX,maxY,lX,lY,l:Real;

  Function Max(Const x,y:Real):Real;
  Begin
    If x>y then Max:=x else Max:=y
  End; {Max}

  Function Min(Const x,y:Real):Real;
  Begin
    If x>y then Min:=y else Min:=x
  End; {Min}

  Procedure GrafInic(Const mnX,mnY,mxX,mxY:Real);
    Var gd,gm:Integer;
  Begin
    {grafikanyits:}
    gd:=Detect;
    InitGraph(gd,gm,'');
    ClearDevice;
    SetBkColor(DarkGray);
    {globlis lptkek:}
    minX:=mnX; minY:=mnY; maxX:=mxX; maxY:=mxY;
    lX:=GetMaxX/(maxX-minX+1); lY:=GetMaxY/(maxY-minY+1);
    l:=Min(lX,lY);
    {tengelyek:}
    SetLineStyle(DottedLn,0,NormWidth);
    Line(Round((0-minX)*l),0,Round((0-minX)*l),GetMaxY);
    Line(0,Round((0-minY)*l),GetMaxX,Round((0-minY)*l));
    SetLineStyle(SolidLn,0,ThickWidth);
  End;{GrafInic}

  Procedure PontRajzol(Const p:TPont; szin,stilus:Byte);
    Var
      x0,y0:Integer;
  Begin
    SetColor(szin);
    SetFillStyle(SolidFill,szin);
    x0:=Round((p.x-minX)*l); y0:=Round((p.y-minY)*l);
    FillEllipse(x0,y0,pR,pR);
  End;{PontRajzol}

  Procedure SzakaszRajzol(Const s:TSzakasz; szin,stilus:Byte);
    Var
      x1,y1,x2,y2:Integer;
  Begin
    PontRajzol(s.p,szin,stilus);
    PontRajzol(s.q,szin,stilus);
    x1:=Round((s.p.x-minX)*l); y1:=Round((s.p.y-minY)*l);
    x2:=Round((s.q.x-minX)*l); y2:=Round((s.q.y-minY)*l);
    SetColor(szin);
    SetLineStyle(stilus,0,ThickWidth);
    Line(x1,y1,x2,y2);
  End;{SzakaszRajzol}

