Program PontSorrend; {SzP 05.02.11.}
(*
  Geometriai feladat 2.
  Feladat: adott N (nem kollineris) pont. Adjuk meg a pontok
           olyan sorrendjt, amelyben az egymst kvetket,
           s az utolst az elsvel sszektve zrt, nem-metsz
           poligont kapunk.
*)
  Uses
    Newdelay,Crt22,Crt,Graph;
  {$i AltRutin.inc}{$i SzakPont.inc}{$i GeoGraf.inc}
  Const
    foCim='N ponton nyugv zrt poligon';
  Var
    p,pp:TPontok;
    s:TSzakasz;
    N,i,k:Integer;

  Function EgyEgyenesenE(Const N:Integer; Const p:TPontok):Boolean;
  (*
    Uf: EgyEgyenesenE(N,p)=BRMELY i ELEME [3..N] :
                           LTEZIK t ELEME Vals : p[i]=p[1]+t*(p[2]-p[1])
  *)
    Var
      i,j:Integer;
      rajtaVan:Boolean;
      t:Real;
  Begin
    {p[j:2..N] pont keresse: p[1].x<>p[j].x}
    j:=2;
    While (j<=N) and (p[j].x=p[1].x) do
      Inc(j);
    If j<=N then
    Begin {nem mind van a p[1] "fltt", pl. a j. ilyen}
      If j>2 then {garantltan nem esnek egy egyenesre, hiszen
                   a j-1.-ig p[1]-en tmen fgglegesre, s
                   a j. egy "ferde" egyenesre esik}
      Begin
        EgyEgyenesenE:=False
      End
        else {j=2, lehet, hogy egy "ferde" egyenesre esik mind}
      Begin
        {p[1]->p[2] irnytangense:}
        t:=(p[2].y-p[1].y)/(p[2].x-p[1].x);
        rajtaVan:=True;
        i:=2;
        While (i<N) and rajtaVan {az i. a p[1]->p[2] egyenesen nyugszik} do
        Begin
          Inc(i);
          rajtaVan:=p[i].y=p[1].y+(p[i].x-p[1].x)*t
        End;
        EgyEgyenesenE:=rajtaVan
      End{If j in}
    End
      else
    Begin {egyetlen fggleges egyenesen fekszenek}
      EgyEgyenesenE:=True
    End{If j<=N}
  End;{EgyEgyenesenE}

  Procedure Poligon(Const N:Integer; Var p:TPontok;
                                     Var pp:TPontok);
  (*
    Uf: a feladat meghatrozsa szerinti sorrendben rja ki a pontokat
  *)
    Var
      i,k,db:Integer;

    Procedure PolarSzogSzerintRendez(Const N:Integer; Var p:TPontok);
    (*
      Uf: BRMELY i ELEME [1..N-1] : fi(q,p[i])<fi(q,p[i+1])  S
          q ELEME p[1..N] S
          BRMELY i ELEME [1..N] : q.x<=p[i].x VAGY (q.x=p[i].x => q.y<=p[i].y)
      Def: fi: TPont x TPont -> Vals
           fi(q,p):=arctg((p.y-q.y)/(p.x-q.x))
      Megj.: az algoritmus mkdik az arctg nlkl is, hiszen
          rendezshez fi helyett tg(fi) is j, azaz a rendezs a
          ((p[i].y-q.y)/(p[i].x-q.x))<((p[i+1].y-q.y)/(p[i+1].x-q.x))
          alapjn is elvgezhet
    *)
      Type
        TIrTg=Record vegtelen:Boolean; irTg:Real End;
      Var
        i,j,
        mini,legbal:Integer;
        sj,smini:Real;
        q:TPont;
        polSzog:Array [1..MaxN] of TIrTg;
        ir:TIrTg;
    Begin
      {legbal-alul lev kikeresse:}
      legbal:=1;
      For i:=2 to N do
      Begin
        If (p[legbal].x>p[i].x) or
           (p[legbal].x=p[i].x) and (p[legbal].y>p[i].y) then legbal:=i;
      End;{For i}
      {polrszg-szmts:}
      For i:=1 to N do
      Begin
        If (p[legbal].x=p[i].x) then
        Begin
          polSzog[i].vegtelen:=True;
          polSzog[i].irTg:=0;
        End
          Else
        Begin
          polSzog[i].vegtelen:=False;
          polSzog[i].irTg:=(p[legbal].y-p[i].y)/(p[legbal].x-p[i].x);
        End;{If (p[legbal].x}
      End;{For i}
      {legbal-alul levnek az 1. helyre ttele:}
      q:=p[legbal]; p[legbal]:=p[1]; p[1]:=q;
      ir:=polSzog[legbal]; polSzog[legbal]:=polSzog[1]; polSzog[1]:=ir;
      {a tbbi polrszg szerinti rendezse:}
      For i:=2 to N-1 do
      Begin

(*
        mini:=i;
        For j:=i+1 to N do
        Begin
          If not polSzog[j].vegtelen and
                 (polSzog[mini].vegtelen or
                  (not polSzog[mini].vegtelen and
                  (polSzog[mini].irTg>polSzog[j].irTg))) or
                 (not polSzog[mini].vegtelen and
                  (polSzog[mini].irTg=polSzog[j].irTg) and
                  (p[mini].x>p[j].x))
             {p[j]>p[mini]} then mini:=j
        End;{For j}
        q:=p[i]; p[i]:=p[mini]; p[mini]:=q;
        ir:=polSzog[i]; polSzog[i]:=polSzog[mini]; polSzog[mini]:=ir;
*)

        mini:=i;
        For j:=i+1 to N do
        Begin
          sj:=(p[j].y-p[1].y)*(p[mini].x-p[1].x);
          smini:=(p[mini].y-p[1].y)*(p[j].x-p[1].x);
          If (sj<smini) or
             ((sj=smini) and (p[j].x>p[mini].x)) or
             ((sj=smini) and (p[j].x=p[mini].x) and (p[j].y>p[mini].y))
             {p[j]>p[mini]} then mini:=j
        End;{For j}
        q:=p[i]; p[i]:=p[mini]; p[mini]:=q;

     End;{For i}
    End;{PolarSzogSzerintRendez}

  Begin{Poligon}
    PolarSzogSzerintRendez(N,p);
    {sorrend-korrekci --
     az utols nhny egy egyenesen nyugv sorrendje fordtott:}
    i:=N-1;
    While (p[n].y-p[1].y)*(p[i].x-p[1].x)=
          (p[i].y-p[1].y)*(p[n].x-p[1].x) do Dec(i);
    Writeln('Az albbi sorrendben kell a pontokat sszektni:');
    db:=0;
    {a fordtottak:}
    For k:=1 to i do
    Begin
      WritelnTPont(p[k]); Inc(db); pp[db]:=p[k];
    End;
    {a "tbbiek":}
    For k:=n downto i+1 do
    Begin
      WritelnTPont(p[k]); Inc(db); pp[db]:=p[k];
    End;
    WritelnTPont(p[1]); Inc(db); pp[db]:=p[1];
  End;{Poligon}

Begin
  UjLap(foCim+' -- beolvass',0);
  Repeat
    Writeln('Adja meg a pontok szmt!');
    {$i-}
    Readln(N);
    {$i+}
  Until (IOResult=0) and (N in [0..MaxN]);
  For i:=1 to N do
  Begin
    Repeat
      Writeln('Adja meg a(z) ',i,'. pontot!');
    Until ReadlnTPont(p[i]);
  End;
  UjLap(foCim+' -- feldolgozs',-1);
  If EgyEgyenesenE(N,p) then
  Begin
    Writeln('Egy egyenesen fekszenek. Nincs megolds.')
  End
     else
  Begin
    Poligon(N,p,pp);
  End;
  BillreVar;
  {Kirajzols:}
  minX:=pp[1].x; minY:=pp[1].y;
  maxX:=minX;    maxY:=minY;
  For i:=2 to n do
  Begin
    minX:=Min(minX,pp[i].x); minY:=Min(minY,pp[i].y);
    maxX:=Max(maxX,pp[i].x); maxY:=Max(maxY,pp[i].y);
  End;
  GrafInic(minX,minY,maxX,maxY);
  For k:=1 to n do
  Begin
    s.p:=pp[k]; s.q:=pp[k+1]; SzakaszRajzol(s,Red,SolidLn);
  End;
  BillreVar;
End.