(*
  A szakasz s pont tpusnak megvalstsa.
  Export:
    Konst MaxN:Egsz
    Tpus TPont=Rekord(x,y:Vals)
          Eljrs WritelnTPont(Konst p:TPont)
                  ReadlnTPont(Vlt p:TPont)
                  ForgsIrny(Konst p,q,r:TPont)
    Tpus TPontok=Tmb(1..MaxN:TPont)
    Tpus TSzakasz=Rekord(p,q:TPont)
          Eljrs  WritelnTSzakasz(Konst s:TSzakasz)
                   ReadlnTSzakasz(Vlt s:TSzakasz)
          Fggvny SzakaszonE(Konst s:TSzakasz; r:TPont):Logikai
                   SzakaszPrMetszE(Konst s1,s2:TSzakasz):Logikai
          Eljrs  SzakaszPrMetszspont(Konst s1,s2:TSzakasz; Vlt r:TPont)
*)
  Const
    MaxN = 20;
  Type
    TPont = Record x,y:Real End;
    Procedure WritelnTPont(Const p:TPont);
    Begin
      Writeln(' x:',p.x:6:3,' , y:',p.y:6:3);
    End;{WritelnTPont}
    Function ReadlnTPont(Var p:TPont):Boolean;
    Begin
      {$i-}
      Write('x-,y-koordintk:');
      Readln(p.x,p.y);
      {$i+}
      ReadlnTPont:=IOResult=0
    End;{ReadlnTPont}
    Function ForgasIrany(Const p,q,r:TPont):Integer;
    (*
      Uf: p->q->r jobbforgs => ForgasIrany(p,q,r)=+1
          p->q->r balforgs  => ForgasIrany(p,q,r)=-1
          p-q-r kollinerisak => ForgasIrany(p,q,r)=0
    *)
      Var
        keresztSzorzat:Real;
    Begin
      keresztSzorzat:=(q.y-p.y)*(r.x-p.x)-(r.y-p.y)*(q.x-p.x);
      If
        keresztSzorzat<0 then ForgasIrany:=-1 else if
        keresztSzorzat>0 then ForgasIrany:=+1
                         else ForgasIrany:=0
      {EndIf}
    End;{ForgasIrany}

  Type
    TPontok = Array [1..MaxN] of TPont;

  Type
    TSzakasz = Record p,q:TPont End;
    Procedure WritelnTSzakasz(Const s:TSzakasz);
    Begin
      Write('Kezdpont: '); WritelnTPont(s.p);
      Write('Vgpont: ');   WritelnTPont(s.q);
    End;{WritelnTSzakasz}
    Function ReadlnTSzakasz(Var s:TSzakasz):Boolean;
    Begin
      Writeln('Adja meg a kezd- s vgpontot:');
      ReadlnTSzakasz:=ReadlnTPont(s.p) and ReadlnTPont(s.q);
    End;{ReadlnTSzakasz}
    Function SzakaszonE(Const s:TSzakasz; Const r:TPont):Boolean;
    (*
      Uf: az s szakaszra illeszkedik az r pont
    *)
    Begin
      SzakaszonE:={az s EGYENESre illeszkedik-e}
                  ((r.x-s.p.x)*(s.q.y-s.p.y)=(r.y-s.p.y)*(s.q.x-s.p.x)) and
                  {az s SZAKASZra illeszkedik-e}
                  ((s.p.x<=r.x) and (r.x<=s.q.x) or (s.q.x<=r.x) and (r.x<=s.p.x))
    End;{Szakaszon}

    Function SzakaszParMetszoE(Const s1,s2:TSzakasz):Boolean;
      Var
        fpq1,fpq2,fqp1,fqp2:Integer{-1,0,+1};
    Begin
      fpq1:=ForgasIrany(s1.p,s1.q,s2.p);
      fpq2:=ForgasIrany(s1.p,s1.q,s2.q);
      fqp1:=ForgasIrany(s2.p,s2.q,s1.p);
      fqp2:=ForgasIrany(s2.p,s2.q,s1.q);
      SzakaszParMetszoE:=(fpq1*fpq2<0) and (fqp1*fqp2<0) or
                         SzakaszonE(s1,s2.p) or
                         SzakaszonE(s1,s2.q) or
                         SzakaszonE(s2,s1.p) or
                         SzakaszonE(s2,s1.q)
    End;{SzakaszParMetszoE}

    Procedure SzakaszParMetszespont(Const s1,s2:TSzakasz; Var r:TPont);
    (*
      Ef: SzakaszParMetszoE(s1,s2) -- s1, s2 egymst metsz szakaszok
      Uf: r rajta van az s1-n s az s2 is
    *)
      Var
       ax,aax,bx,bbx,
       ay,aay,by,bby,
       t:Real;
    Begin
      ax:=s1.p.x; bx:=s1.q.x-s1.p.x; aax:=s2.p.x; bbx:=s2.q.x-s2.p.x;
      ay:=s1.p.y; by:=s1.q.y-s1.p.y; aay:=s2.p.y; bby:=s2.q.y-s2.p.y;
      t:=((ay-aay)*bx+(aax-ax)*by)/(bby*bx-bbx*by);
      r.x:=s2.p.x+t*(s2.q.x-s2.p.x);
      r.y:=s2.p.y+t*(s2.q.y-s2.p.y);
    End;{SzakaszParMetszespont}
